/*

	by Serge FANTINO - fantino@math.unice.fr
	
*/

#ifndef SPLITER_H
#define SPLITER_H

#include <View.h>

#define K_SET_HORIZONTAL 'kSHZ'
#define K_SET_VERTICAL 'kSVT'

void draw_separator(BView *owner,orientation posture);

class KSeparator : public BView {
public:

	KSeparator(int height,orientation posture,const char *name);
	
	orientation	Posture();
	virtual void Draw(BRect update);
	
private:

	orientation fPosture;
};

class KSplit : public KSeparator {
public:

	KSplit(int height,orientation posture,const char *name);
	
	void SetLimits(float min,float max);
	
	virtual void Draw(BRect update);
	
	virtual void AllAttached(void);

	virtual void MouseDown(BPoint where);
	virtual void MouseUp(BPoint where);
	virtual void MouseMoved(BPoint point, uint32 transit, const BMessage *message);

	void SplitTo(BPoint left_top,BView *source=NULL);
private:

	orientation fPosture;
	bool	fTracking;
	BPoint	fOffset;
	//BPoint	fMin,fMax;
	float	fMin,fMax,fBeforeHiddingSize;
};

// -----------------------------------------------

struct simple_pack_info;

class KSplitPane : public BView {
public:
	KSplitPane(BRect rect,const char *name,orientation posture,uint32 resizingMode=0,uint32 flags=0);
	~KSplitPane();
	
	orientation Posture();
	void SetPosture(orientation posture);
	
	virtual void AttachedToWindow(void) ;
	
	void AddChild(BView *view);
	status_t RemoveChild(BView *view);
	status_t HideChild(BView *view);
	int32 IndexOf(BView *view);
	
	virtual void MessageReceived(BMessage *message);
	
	void SetFollowAllView(BView *view);
	void ResetFollowAll();
	
protected:
	friend KSplit;

	void really_add_child(simple_pack_info *info,simple_pack_info *previous);
	
	void pack_everything();
	
	void resize_by(float x,float y);

private:
	typedef BView inherited;	
	
	orientation fPosture;
	
	BList *fQueue;
	BList *fInfo;
	bool fFirstTime;
};

#endif