//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998-1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

/*

	this is the tips system:
	
*/

#ifndef TIPS_H
#define TIPS_H

#include <SupportKit.h>
#include <AppKit.h>
#include <InterfaceKit.h>

// display the tips in a pretty floatting window, with yellow bckgrnd...
class KTipsWindow : public BWindow {
public:
	
	KTipsWindow(BView *owner,BPoint where,const char *text);
	
	virtual void Quit();
	
};

class KTips;

class KTipsManager {
public:

	KTipsManager(BWindow *win,bool enabled=true);

	void AddTips(const char *tips,BView *owner);
	void create_tips(int32 ID,const char *tips,BView *owner,BView *target);
	
	virtual void ShowTips(KTips *tips,BPoint where);
	
	virtual void HideTips();
	
	virtual void Pulse();
	
	static filter_result filter(BMessage *message, 
         BHandler **target, 
         BMessageFilter *messageFilter);
	
private:
	bool	fEnabled;
	int32	fID,fCurrentID,fLastID;
	bool	fActive;
	KTips	*fCurrentTips;
	BPoint	fWhere;
	bool	fNeedToShow,fWait;
	KTipsWindow *fTipsWindow;
	
	BWindow	*fWindow;

};

// 
class KTips : public BMessageFilter {
public:

	KTips(int32 ID,const char *tipsText,BView *owner,KTipsManager *fManager);
	
	virtual filter_result Filter(BMessage *message, BHandler **target);
	
	const char *Text();
	
private:
	friend KTipsManager;
	
	int32	fID;
	BString	fTipsText;
	BView	*fOwner;
	KTipsManager	*fManager;
};

#endif
