//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998,1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef TAB_VIEW_H
#define TAB_VIEW_H

class KTab : public BTab { // -----------------------------------------------------
public:
	KTab(BView * tabView = NULL);
    KTab(BMessage *archive);
    
    virtual void Select(BView *owner);
    virtual void Deselect();
    
    virtual void DrawTab(BView *owner,BRect frame,tab_position position,bool full);
private:
	bool 	fFirstTime;
};

class KTabView : public BTabView {
public:
	KTabView(BRect frame, const char *name, 
         button_width width = B_WIDTH_FROM_WIDEST, 
         uint32 resizingMode = B_FOLLOW_ALL, 
         uint32 flags = B_FULL_UPDATE_ON_RESIZE | B_WILL_DRAW | B_NAVIGABLE_JUMP | B_FRAME_EVENTS | B_NAVIGABLE);
         
    virtual void AttachedToWindow();
    virtual void AllAttached();
    
  	virtual void AddTab(BView *target, BTab *tab = NULL);
  	
  	virtual void GetPreferredSize(float *width,float *height);
  	
  	// drawing part
  	virtual BRect TabFrame(int32 tabIndex) const;
  	virtual void DrawBox(BRect selTabRect);
  	virtual BRect DrawTabs();
  	
private:

	float	fLeftTabsOffset;
  	
}; 
      
#endif
