//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998-1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

#include <stdio.h>

#include <AppKit.h>
#include <InterfaceKit.h>
#include <StorageKit.h>
#include <SupportKit.h>

#include "pack_view.h"
#include "tab_view.h"
#include "text_control.h"

#include "spliter.h"

#include "tips.h"

filter_result quit_requested_filter(BMessage *message, 
         BHandler **target, 
         BMessageFilter *messageFilter)
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return B_SKIP_MESSAGE;
}

filter_result about_requested_filter(BMessage *message, 
         BHandler **target, 
         BMessageFilter *messageFilter)
{
	(new BAlert("About","Kool lib demo app\n\nby Serge Fantino","OK"))->Go(NULL);
}

filter_result debug_filter(BMessage *message, 
         BHandler **target, 
         BMessageFilter *messageFilter)
{
	message->PrintToStream();
}

#define K_FLAG B_WILL_DRAW|B_FULL_UPDATE_ON_RESIZE

main() {

	BApplication *app=new BApplication("application/x-vnd.kmsf-LMTest");
	// ----
	BWindow *win=new BWindow(BRect(50,50,100,100),"Layout Manager lib Test",B_TITLED_WINDOW,0);
	win->Lock();
	KPackView *pack=new KPackView(win->Bounds(),"pack",B_FOLLOW_ALL,B_WILL_DRAW,B_NO_BORDER);
	win->AddChild(pack);
	// ----
	KTipsManager *tips=new KTipsManager(win);
	// ----
	BView *pp=NULL;
	BMenuBar *mb=new BMenuBar(BRect(0,0,10,10),"menu_bar",B_FOLLOW_ALL);
	BMenu *mn=new BMenu("File");
	mn->AddItem(new BMenuItem("About",new BMessage(B_ABOUT_REQUESTED),'A'));
	mn->AddSeparatorItem();
	mn->AddItem(new BMenuItem("Quit",new BMessage(B_QUIT_REQUESTED),'Q'));
	mb->AddItem(mn);
	pack->PackChild(mb,K_TOP,K_LEFT,K_FILL_X,BPoint(-1,0));// add neg border to avoid artefact when resizing...
	pack->PackChild(pp=new BButton(BRect(0,0,100,10),"up","upper side",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X);
	tips->AddTips("c'est un message a la con",pp);
	//pack->PackChild(new KSplit(5,B_HORIZONTAL,"xxx"),K_TOP,K_LEFT,K_FILL_X);
	pack->Split(K_SPLITER);
	pack->PackChild(pp=new BButton(BRect(0,0,100,10),"bottom","bottom",NULL,0,K_FLAG),K_BOTTOM,K_LEFT,K_FILL_X);
	tips->AddTips("this is a useless button",pp);
	pack->PackChild(pp=new BButton(BRect(0,0,10,10),"left","left side",NULL,0,K_FLAG),K_LEFT,K_TOP,K_FILL_Y);
	tips->AddTips("there's a pb with the slider",pp);
	pack->Split();
	//pack->PackChild(new KSplit(5,B_VERTICAL,"xxx"),K_LEFT,K_TOP,K_FILL_Y);
	KTabView *tv=new KTabView(BRect(0,0,50,50),"tab_view");
/*
	KPack *pack_list1[]={
			new KPack(new BButton(BRect(0,0,100,10),"1","first",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X),
			new KPack(new BButton(BRect(0,0,100,10),"2","second",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X),
			new KPack(new BTextControl(BRect(0,0,100,10),"text1","some too long label","some odd text",NULL),K_TOP,K_LEFT,K_FILL_X),
			new KPack(new BTextControl(BRect(0,0,100,10),"text2","some very very too long label","some odd text",NULL),K_TOP,K_LEFT),
			new KPack(tv,K_FULL,K_LEFT,K_FILL_BOTH),
			NULL
	};
*/
	KPack *pack_list2[]={
			new KPack(new BButton(BRect(0,0,200,10),"1","first",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X),
			new KPack(new BButton(BRect(0,0,100,10),"2","second",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X),
			new KPack(new BButton(BRect(0,0,100,10),"3","three",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X),
			new KPack(new BButton(BRect(0,0,100,10),"4","four",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X),
			NULL
	};
	KPack *pack_list3[]={
			new KPack(new KTextControl(BRect(0,0,100,10),"text1","some too long label","some odd text",130,NULL),K_TOP,K_LEFT,K_FILL_X,BPoint(0,5)),
			new KPack(new KTextControl(BRect(0,0,100,10),"text2","some very very too long label","some odd text",130,NULL),K_TOP,K_LEFT,K_FILL_X),
			new KPack(new KTextControl(BRect(0,0,100,10),"text3","some label","some odd text",130,NULL),K_TOP,K_LEFT,K_FILL_X,BPoint(0,5)),
			new KPack(new KTextControl(BRect(0,0,100,10),"text3","some label, yes...","some odd text",130,NULL),K_TOP,K_LEFT,K_FILL_X),
			NULL
	};
	BTextView *txt=new BTextView(BRect(0,0,50,50),"text_view",BRect(0,0,1000,50),B_FOLLOW_ALL,B_WILL_DRAW);
	txt->MakeResizable(false);
	KPack *pack_list4[]={
			new KPack(new BScrollView("scroll_view",txt,B_FOLLOW_ALL,0,false,true),K_FULL,K_LEFT,K_FILL_BOTH),
			NULL
	};
	tv->AddTab(new KPackView("tab zero",pack_list4));
	//tv->AddTab(new KPackView("tab one",pack_list2));
	KPackView *temp_pack=new KPackView(BRect(0,0,10,10),"tab one",B_FOLLOW_ALL,0);
	BRadioButton *rb=NULL;
	rb=new BRadioButton(BRect(0,0,10,10),"radio1","BeOS",new BMessage('xxxx'));
	tips->AddTips("the only one",rb);
	temp_pack->PackChild(rb,K_TOP,K_LEFT);
	rb=new BRadioButton(BRect(0,0,10,10),"radio2","MacOS Z",new BMessage('xxxx'));
	temp_pack->PackChild(rb,K_TOP,K_LEFT);
	rb=new BRadioButton(BRect(0,0,10,10),"radio3","Win99",new BMessage('xxxx'));
	temp_pack->PackChild(rb,K_TOP,K_LEFT);
	rb=new BRadioButton(BRect(0,0,10,10),"radio4","Linux",new BMessage('xxxx'));
	temp_pack->PackChild(rb,K_TOP,K_LEFT);
	tv->AddTab(temp_pack);
	tips->AddTips("there's a problem here cause radio buttons are added after the handler is set...",temp_pack);
	tv->AddTab(new KPackView("tab two",pack_list3));
	//pack->PackChild(pack_list1);
	
			pack->PackChild(new BButton(BRect(0,0,100,10),"1","first",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X);
			pack->PackChild(new BButton(BRect(0,0,100,10),"2","second",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X);
			pack->PackChild(new BTextControl(BRect(0,0,110,10),"text1","some too long label","some odd text",NULL),K_TOP,K_LEFT,K_FILL_X);
			BMenu *test=new BPopUpMenu("some menu");
			test->AddItem(new BMenuItem("BeOS",new BMessage('xxxx')));
			test->AddItem(new BMenuItem("MacOS",new BMessage('xxxx')));
			test->AddItem(new BMenuItem("WinOS",new BMessage('xxxx')));
			test->AddItem(new BMenuItem("Linux",new BMessage('xxxx')));
			BMenuField *xx=new BMenuField(BRect(0,0,100,10),"menu","target OS:",test);
			xx->SetDivider(100.0);
			pack->PackChild(xx,K_TOP,K_LEFT);
			tips->AddTips("there's a problem with popup menu...",xx);
			pack->PackChild(pp=new BTextControl(BRect(0,0,100,10),"text2","some very very too long label","some odd text",NULL),K_TOP,K_LEFT);
			tips->AddTips("c'est un autre message a la con",pp);
			pack->PackChild(new BButton(BRect(0,0,100,10),"3","a resizable one",NULL,0,K_FLAG),K_TOP,K_LEFT,K_FILL_X);
			pack->Split();
			pack->PackChild(tv,K_FULL,K_LEFT,K_FILL_BOTH);
			tips->AddTips("did you notice who tips are often useless ?",tv);
	// ---
	app_info info;
	be_app->GetAppInfo(&info);
	BEntry app_entry(&info.ref);
	BDirectory app_dir;
	app_entry.GetParent(&app_dir);
	BPath path(&app_dir,"../readme.txt");
	BFile read_me(path.Path(),B_OPEN);
	puts(path.Path());
	if (read_me.InitCheck()==B_NO_ERROR) {
		off_t size;
		read_me.GetSize(&size);
		txt->SetText(&read_me,0,size);
	} else
		txt->SetText("there 's supposed to be a readme file distributed with the lib...");
	// ----
	win->AddCommonFilter(new BMessageFilter(B_QUIT_REQUESTED,quit_requested_filter));
	win->AddCommonFilter(new BMessageFilter(B_ABOUT_REQUESTED,about_requested_filter));
	//win->AddCommonFilter(new BMessageFilter(B_PULSE,debug_filter));
	win->Unlock();
	win->Show();
	// ----	
	app->Run();
	// ----
	delete tips;
	delete app;
	
}