//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#include "wApp.h"

#include "constant.h"
 
//KTipsManager *tips;

wApplication::wApplication(const char *signature):
BApplication(signature)
{
	fCountDocumentWindow=0;
	fDocumentWindowIndex=1;
	//tips=new KTipsManager();
}

wApplication::~wApplication()
{
	//delete tips;
}

void wApplication::MessageReceived(BMessage *message)
{
	switch (message->what) {
		case K_ADD:
			++fCountDocumentWindow;
			break;
		case K_CLOSE:
			--fCountDocumentWindow;
			if (fCountDocumentWindow<=0)
				Quit();
			break;
		default:
			BApplication::MessageReceived(message);
	}
}	

int32 wApplication::GetNewIndex() {return fDocumentWindowIndex++;}
	
bool wApplication::QuitRequested(void)
{
	//return (fCountDocumentWindow==0);
	return true;
}
	
// ------------------------------------------------------------

wDocumentWindow::wDocumentWindow(BRect frame,const char *title,
	window_type type,uint32 flags,uint32 workspace):
BWindow(frame,title,type,flags,workspace)
{
	Init();
}
	
wDocumentWindow::wDocumentWindow(BRect frame,const char *title,
	window_look look,window_feel feel,uint32 flags,uint32 workspace):
BWindow(frame,title,look,feel,flags,workspace)
{
	Init();
}

void wDocumentWindow::Init()
{
	BMessage birth(K_ADD);
	be_app->PostMessage(&birth,be_app);
}
			
void wDocumentWindow::Quit()
{
	BMessage death(K_CLOSE);
	be_app->PostMessage(&death,be_app);
	BWindow::Quit();
}