//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#include <stdio.h>

#include "wApp.h"

#include "wCommandEditor.h"

#include "constant.h"

#include "tab_view.h"
#include "wMessageUtils.h"
#include "wDBObjects.h"

// ********************************************************************** //
//  COMMAND - COMMAND - COMMAND - COMMAND - COMMAND - COMMAND - COMMAND - //
// ********************************************************************** //

wCommandEditor::wCommandEditor(BRect frame,const char *name,
	//bool propagate,
	uint32 resizingMode,uint32 flags,border_style border):
inherited(frame,name,resizingMode,flags,border)
{
	fCommandMenu = new BMenu("MessageTypeMenu");
	BuildCommandMenu(fCommandMenu);
	// ---
	SetLabel("what");
	//tips->AddTips("the what field of the current message",this);
/*
	BMenuField* menuField = new BMenuField(BRect(0,0,100,20), "MenuField", "Message Type:", fCommandMenu);
	menuField->SetDivider(75.0);
	PackChild(menuField,K_TOP,K_LEFT,K_FILL_X);
*/
	BMenuField* menuField = new BMenuField(BRect(0,0,110,20), "what:menu", "Predefined values", fCommandMenu);
	menuField->SetDivider(100.0);
	fCommandWhatCode=new BTextControl(BRect(0,0,180,20),"what:value","what value","",new BMessage(K_SET));
	fCommandWhatCode->SetDivider(100.0);
	PackChild(fCommandWhatCode,K_TOP,K_LEFT,0,BPoint(2,2));
	PackChild(menuField,K_TOP,K_LEFT,K_FILL_X,BPoint(2,2));
}
 	
void wCommandEditor::BuildCommandMenu(BMenu *menu)
{
	menu->AddItem(new_command_item(B_GET_PROPERTY));
	menu->AddItem(new_command_item(B_SET_PROPERTY));
	menu->AddItem(new_command_item(B_EXECUTE_PROPERTY));
	menu->AddItem(new_command_item(B_COUNT_PROPERTIES));
	menu->AddItem(new_command_item(B_CREATE_PROPERTY));
	menu->AddItem(new_command_item(B_DELETE_PROPERTY));
	menu->AddItem(new_command_item(B_GET_SUPPORTED_SUITES));
	// ---
	menu->AddItem(new BSeparatorItem());
	// ---
	menu->AddItem(new_command_item(B_ABOUT_REQUESTED));
	menu->AddItem(new_command_item(B_QUIT_REQUESTED));
	// ---
	menu->AddItem(new BSeparatorItem());
	// ---
	menu->AddItem(new_command_item(B_SIMPLE_DATA));
	menu->AddItem(new_command_item(B_REFS_RECEIVED));
	menu->AddItem(new_command_item(B_ARCHIVED_OBJECT));
	// ---
	menu->AddItem(new BSeparatorItem());
	// ---
	menu->AddItem(new_command_item(B_REPLY));
	menu->AddItem(new_command_item(B_MESSAGE_NOT_UNDERSTOOD));
	//menu->ItemAt(0)->SetMarked(true);
	menu->SetLabelFromMarked(true);
	//SetCommand(0);
}

void wCommandEditor::AttachedToWindow()
{
	inherited::AttachedToWindow();
	fCommandMenu->SetTargetForItems(this);
	fCommandWhatCode->SetTarget(this);
}


void wCommandEditor::MessageReceived(BMessage *msg)
{
	switch (msg->what) {
		case K_SELECT:{
			int32 command;
			if (msg->FindInt32("command",&command)==B_OK) {
				fCommand=command;
				char xxx[8+1];
				seewhat(fCommand,xxx);
				fCommandWhatCode->SetText(xxx);
			}
			break;}
		case K_SET:{
			uint32 command;
			const char *text=fCommandWhatCode->Text();
			if (strlen(text)==4) {
				uint32 *pcommand;
				pcommand=(uint32*)(text);
				SetCommand(*pcommand);
			} else if (sscanf(text,"%lui",&command)==1) {
				SetCommand(command);
			} else {
			
			}
			break;}
		default:
			inherited::MessageReceived(msg);
	}
}

void wCommandEditor::SetCommand(int32 command)
{
	fCommand=command;
	// select correct item...
	BMenuItem *item;
	BMessage *mess;
	int32 internal_command;
	bool find=false;
	for (int32 count=fCommandMenu->CountItems();count>0;) {
		if (((mess=(item=fCommandMenu->ItemAt(--count))->Message())!=NULL)
			&&(mess->FindInt32("command",&internal_command)==B_OK)
			&&internal_command==command) {
			item->SetMarked(true);
			find=true;
			break;
		}
	}
	char xxx[8+1];
	seewhat(command,xxx);
		if (!find) {
			if (fCommandMenu->Superitem()!=NULL)
				fCommandMenu->Superitem()->SetLabel(xxx);
		}
	fCommandWhatCode->SetText(xxx);
}
 	
void wCommandEditor::MimicMessage(BMessage *msg)
{
	msg->what=fCommand;
}
