//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#include <InterfaceKit.h>

#include "wInfoViewer.h"

wMessageInfoViewer::wMessageInfoViewer(BRect frame, const char *name, 
		//bool propagate,
		uint32 resizingMode,uint32 flags):
inherited(frame,name,resizingMode,flags,B_FANCY_BORDER)
{
	fIsSystem=new BCheckBox(BRect(0,0,100,10),"_is_system_","IsSystem",NULL);
	fWasDelivered=new BCheckBox(BRect(0,0,100,10),"_delivered_","WasDelivered",NULL);
	fIsSourceRemote=new BCheckBox(BRect(0,0,100,10),"_is_source_remote","IsSourceRemote",NULL);
	fIsSourceWaiting=new BCheckBox(BRect(0,0,100,10),"_is_source_waiting_","IsSourceWaiting",NULL);
	fIsReply=new BCheckBox(BRect(0,0,100,10),"_is_reply_","IsReply",NULL);
	fWasDropped=new BCheckBox(BRect(0,0,100,10),"_was_dropped_","WasDropped",NULL);
	fIsSystem->SetEnabled(false);
	fWasDelivered->SetEnabled(false);
	fIsSourceRemote->SetEnabled(false);
	fIsSourceWaiting->SetEnabled(false);
	fIsReply->SetEnabled(false);
	fWasDropped->SetEnabled(false);
}

void wMessageInfoViewer::AttachedToWindow(bool first_time)
{
	if (first_time) {
		PackChild(fIsSystem,K_TOP,K_LEFT,K_FILL_X);
		PackChild(fWasDelivered,K_TOP,K_LEFT,K_FILL_X);
		PackChild(fIsSourceRemote,K_TOP,K_LEFT,K_FILL_X);
		PackChild(fIsSourceWaiting,K_TOP,K_LEFT,K_FILL_X);
		PackChild(fIsReply,K_TOP,K_LEFT,K_FILL_X);
		PackChild(fWasDropped,K_TOP,K_LEFT,K_FILL_X);
	}
}

void wMessageInfoViewer::SetMessage(BMessage *msg)
{
	fIsSystem->SetValue(msg->IsSystem());
	fWasDelivered->SetValue(msg->WasDelivered());
	fIsSourceRemote->SetValue(msg->IsSourceRemote());
	fIsSourceWaiting->SetValue(msg->IsSourceWaiting());
	fIsReply->SetValue(msg->IsReply());
	fWasDropped->SetValue(msg->WasDropped());
}
