//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef MESSAGE_BUILDER_KMSF
#define MESSAGE_BUILDER_KMSF

#include "wApp.h"
#include "pack_view.h"
#include "tab_view.h"
//#include "wSuiteViewer.h"
#include "wDBObjects.h"
#include "wCommandEditor.h"
#include "wDataEditor.h"
#include "wSpecifierEditor.h"
#include "wInfoViewer.h"


// -------------------------

class wMessageDataEditor;

class wMessageEditor : public KPackView {
public:
	wMessageEditor(BRect frame, const char *name, 
		//bool propagate,
		uint32 resizingMode=B_FOLLOW_ALL_SIDES, 
		uint32 flags=0);
 	//virtual void AttachedToWindow();
 	virtual void AllAttached();
 	
 	void SetMessage(BMessage *msg);
 	void MimicMessage(BMessage *msg);
 	
 	void SetMessenger(BMessenger messenger);
 	const BMessenger Messenger();
 	
 	bool Modified();
private:
	typedef KPackView inherited;
	
	BMessage	*fMessage;
	BMessenger	fMessenger;
	
	KTabView	*fTabView;
	
	wCommandEditor				*fCommandEditor;
	wMessageDataEditor			*fMessageDataEditor;
	wMessageSpecifierEditor		*fMessageSpecifierEditor;
	//wSuiteViewer				*fSuiteViewer;
	wMessageInfoViewer			*fMessageInfoViewer;
};

// ---------------------------
/*
class wMessageEditorDialog : public BWindow {
public:
	wMessageEditorDialog(BRect rect,wTable *table);
	
	int32 Go();
	virtual void MessageReceived(BMessage *message);
	
private:
	wMessageEditor	*fEditor;
	wTable			*fTable;
	int32			fResult;
};
*/
// ---------------------------

class wMessageBuilder : public wDocumentWindow {
public:
	wMessageBuilder(BRect frame, const char *title,
		BMessage	*msg,
		BMessenger	sendAddress,
		BHandler	*replyAddress,
		uint32 workspaces = B_CURRENT_WORKSPACE);
	wMessageBuilder(BRect frame,entry_ref *ref,BHandler	*replyAddress);
		
	~wMessageBuilder();	
	
	void Init(BMessage *msg);
	
	virtual void MessageReceived(BMessage *msg);
         
private:
	typedef	wDocumentWindow inherited;

	wMessageEditor	*fEditor;
	BMessenger		fSelfMessenger;// for saving panel
	BMessenger		fSendAddress;
	BHandler		*fReplyAddress;
	BFilePanel		*fSavePanel;
	
	entry_ref		fRef;
	BFile			*fFile;
};

#endif
