//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef SPECIALISED_EDITOR_KMSF
#define SPECIALISED_EDITOR_KMSF

#include <InterfaceKit.h>

#include "wDBObjects.h"

class wSpecialisedEditorDialog : public BHandler, public wDBFieldWidget {
public:
	wSpecialisedEditorDialog(
		BWindow *owner,const char *name,
		wTable *table,const char *fieldName,int32 fieldIndex);
	
	const BWindow *Owner();
	
	virtual BWindow *Go(const char *title)=0;
	
	virtual void ClosingTable();
};

class wColorEditorDialog : public wSpecialisedEditorDialog {
public:
	wColorEditorDialog(
		BWindow *owner,
		wTable *table,const char *fieldName,int32 fieldIndex);
	~wColorEditorDialog();
	
	BWindow *Go(const char *title);
		
	virtual void UpdateCurrentRecord(bool selectionChanged);
	virtual void MessageReceived(BMessage *message);
	
private:
	typedef wSpecialisedEditorDialog inherited;
	BColorControl 	*fColorControl;
	BWindow			*fWindow;
};

class wRefEditorDialog : public wSpecialisedEditorDialog {
public:
	wRefEditorDialog(
		BWindow *owner,
		wTable *table,const char *fieldName,int32 fieldIndex);
	~wRefEditorDialog();
	
	BWindow *Go(const char *title);
		
	virtual void UpdateCurrentRecord(bool selectionChanged);
	virtual void MessageReceived(BMessage *message);
	
private:
	typedef wSpecialisedEditorDialog inherited;
	BFilePanel		*fFilePanel;
};

class wMessageEditor;

class wMessageEditorDialog : public wSpecialisedEditorDialog {
public:
	wMessageEditorDialog(
		BWindow *owner,
		wTable *table,const char *fieldName,int32 fieldIndex);
	~wMessageEditorDialog();
	
	BWindow *Go(const char *title);
		
	virtual void UpdateCurrentRecord(bool selectionChanged);
	virtual void RemoveRecord(wRecord *record);
	virtual void MessageReceived(BMessage *message);
	
	void SaveMessage();
	void QuitMessage();
	
private:
	typedef wSpecialisedEditorDialog inherited;
	wMessageEditor		*fMessageEditor;
	BWindow				*fWindow;
};

#endif