//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef SPECIFIER_EDITOR_KMSF
#define SPECIFIER_EDITOR_KMSF

#include "pack_view.h"
#include "wDBObjects.h"
#include "wCommandEditor.h"

// ---------------------

class wSpecifierEditor : public KPackView, public wDBWidget /*public BInvoker*/ {
public:
	wSpecifierEditor(BRect frame, const char *name, 
		wTable *table,
		//bool propagate=false,
		uint32 resizingMode=B_FOLLOW_ALL_SIDES, 
		uint32 flags=0);
		
	virtual void BuildSpecifierTypeMenu(BMenu *menu);
 	virtual void AttachedToWindow(bool first_time);
 	
 	virtual void MessageReceived(BMessage *msg);
	
	void UpdateCurrentRecord(bool selectionChanged);
private:
	typedef KPackView inherited;
	
	BMenu			*fSpecMenu;
	wFieldControl	*fPropertyName,*fNameValue;
	BMessage		*fSpecifier;
}; 

class wMessageSpecifierViewer : public BOutlineListView, public wDBWidget {
public:
	wMessageSpecifierViewer(BRect frame, const char *name, 
		wTable *table,
		uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP, 
		uint32 flags = B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	
	void MessageReceived(BMessage *message);
	virtual void SelectionChanged(void);
	
	void DisplayMessageSpecifier(BMessage *msg);
	
	BMessage *CurrentSpecifier();
	//void UpdateCurrentSpecifier();
	void UpdateCurrentRecord(bool selectionChanged);
	BMessage *AddSpecifier(BMessage *specifier=NULL);
	void RemoveSpecifier();
	

private:
	typedef BOutlineListView inherited;
}; 

class wMessageSpecifierEditor : public KPackView {
public:
	wMessageSpecifierEditor(BRect frame, const char *name, 
		//bool propagate,
		uint32 resizingMode=B_FOLLOW_ALL_SIDES, 
		uint32 flags=0);
	~wMessageSpecifierEditor();
	
 	virtual void AttachedToWindow(bool first_time);
 	
 	virtual void MessageReceived(BMessage *msg);
 	//void SelectSpecifier(BMessage *msg);
	
	void SetMessage(BMessage *msg);
	void MimicMessage(BMessage *msg);
private:
	typedef KPackView inherited;
	
	wTable						*fSpecifierTable;
	wMessageSpecifierViewer		*fMessageSpecifierViewer;
	wSpecifierEditor			*fSpecifierEditor;
}; 

#endif
