#include "simple_app.h"
#include "siv_window.h"

#include "StorageKit.h"

#include <stdio.h>

class SIVApp : public KSimpleApp 
{
public:
	
	SIVApp():KSimpleApp()
	{
		fSingleWindow=true;
		fMainWindow=NULL;
		if (fSingleWindow) {
			fMainWindow=new SIVWindow(BRect(100,100,200,200),"SimpleImageViewer");
		}
	}
	
	virtual void RefsReceived(BMessage *message)
	{
		puts("open");
		message->PrintToStream();
		entry_ref ref;
		int32 index=0;
		while (message->FindRef("refs",index++,&ref)==B_OK) {
			BEntry entry(&ref);
			if (OpenImage(&entry)==B_OK) break;
		}
	}
	
	virtual void ArgvReceived(int32 argc, char **argv)
	{
		// ignore first arg == app path
		argc--;argv++;
		// iter througth argv
		BEntry entry;
		while (argc-->0) {
			entry.SetTo(*argv,true);
			if (OpenImage(&entry)==B_OK) break;
		}
	}
	
	virtual void ReadyToRun()
	{
		if (fMainWindow!=NULL) fMainWindow->Show();
	}
	
	status_t OpenImage(BEntry *entry)
	{
		BPath path(entry);
		if (fMainWindow!=NULL)
			return fMainWindow->LoadImage(path.Path());
		else {
			SIVWindow *w=new SIVWindow(BRect(100,100,200,200),"SimpleImageViewer");
			status_t err=w->LoadImage(path.Path());
			if (err==B_OK) {
				w->Show();
			} else {
				w->Quit();
			}
			return err;
		}	
	}
	
private:
	SIVWindow *fMainWindow;
	
	bool	fSingleWindow;
};

void main ()
{
	SIVApp *siv_app=new SIVApp();
	SIVWindow *w=new SIVWindow(BRect(100,100,200,200),"SimpleImageViewer");
	siv_app->Run();
	delete siv_app;
}