#include "sfx_menu.h"

// SFXPopUpMenu <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

#define LIGHT_COLOR 250,250,250
#define DARK_COLOR 0,0,0

SFXSeparatorItem::SFXSeparatorItem()
:BSeparatorItem()
{
}

void SFXSeparatorItem::Draw()
{
	rgb_color low=Menu()->LowColor();
	rgb_color high=Menu()->HighColor();
	BSeparatorItem::Draw();
	Menu()->SetLowColor(low);
	Menu()->SetHighColor(high);
}

SFXPopUpMenu::SFXPopUpMenu(const char *name, bool radioMode, 
         bool labelFromMarked, 
         menu_layout layout)
:BPopUpMenu(name,radioMode,labelFromMarked,layout)
{
	fBackground=NULL;
	SetViewColor(B_TRANSPARENT_32_BIT);
	SetLowColor(DARK_COLOR);
	SetHighColor(LIGHT_COLOR);
}

SFXPopUpMenu::~SFXPopUpMenu()
{
	delete fBackground;
}

bool SFXPopUpMenu::AddSeparatorItem()
{
	return AddItem(new SFXSeparatorItem());
}

void SFXPopUpMenu::AttachedToWindow()
{
	inherited::AttachedToWindow();
	BScreen screen(Window());
	BRect bounds=Bounds();
	bounds.OffsetTo(ScreenLocation()+BPoint(1,1));
	screen.GetBitmap(&fBackground,false,&bounds);
	Invalidate();
}

void SFXPopUpMenu::DetachedFromWindow()
{
	delete fBackground;
	fBackground=NULL;
	inherited::DetachedFromWindow();
}
         
void SFXPopUpMenu::DrawBackground(BRect update)
{
	if (fBackground!=NULL) {
		DrawBitmap(fBackground,update,update);
		SetDrawingMode(B_OP_BLEND);
		SetHighColor(DARK_COLOR);
		FillRect(update);
		//SetDrawingMode(B_OP_COPY);
		SetLowColor(DARK_COLOR);
		SetHighColor(LIGHT_COLOR);
	} else {
		inherited::DrawBackground(update);
	}
}

void SFXPopUpMenu::Draw(BRect updateRect)
{
	inherited::Draw(updateRect);
}
